#include "../../particles.lua"
#include "helper.lua"

local active = true
local cooldown = 2
local waited = 0

function staying(target)
    if VecLength(GetBodyVelocity(target)) < 0.05 then return true end
    return false
end
function sleep()
    local selfPos = GetBodyTransform(self).pos

    --Particles
    openParticles(selfPos, 1, 0.9, 0.3)
    --Break sound
    PlaySound(openSnd, selfPos, 2)
    --DELETE SELF
    Delete(self)
    active = false
end

function init()
    self = FindBody("luckyblock", false)

    --SOUNDS
    openSnd = LoadSound("MOD/snd/open.ogg")
end
function tick(dt)
    if not active then return end

    waited = waited + dt
    if waited < cooldown then return end
    if not staying(self) then return end
    waited = 0

    --VARIABLES
    local selfPos = GetBodyTransform(self).pos

    local drops = {
        --Tiny explosion
        [0] = function()
            Explosion(selfPos, 0)
            sleep()
        end,
        --Medium explosion
        [1] = function() 
            Explosion(selfPos, 1)
            sleep()
        end,
        --Large explosion
        [2] = function()
            Explosion(selfPos, 5)
            sleep()
        end,
        --Air strike
        [3] = function()
            Shoot(VecAdd(selfPos, Vec(0, 20, 0)), Vec(0, -1, 0), "rocket")
            sleep()
        end,
        --Bounce
        [4] = function()
            SetBodyVelocity(self, Vec(math.random(-25, 25), 8, math.random(-25, 25)))
            PlaySound(LoadSound("MOD/snd/abilities/bounce.ogg"), selfPos, 2)
        end,
        --Spawn another lucky block
        [5] = function()
            Spawn("MOD/luckyblocks/balloon/block.xml", Transform(VecAdd(selfPos, Vec(0, 0.5, 0))))
            sleep()
        end,
        --Pushes things
        [6] = function()
            push(self, 15, math.random(10, 25))
            sleep()
        end,
        --Pulls things
        [7] = function()
            push(self, 15, -math.random(10, 25))
            sleep()
        end,
        --Spawn another lucky block
        [8] = function()
            Spawn("MOD/dropItems/anvil.xml", Transform(VecAdd(selfPos, Vec(0, 20, 0))))
            sleep()
        end,
        --Spawns a cake
        [9] = function()
            Spawn("MOD/dropItems/cake.xml", Transform(selfPos))
            sleep()
        end,
        --Shoots fire out of the lucky block
        [10] = function()
            napalm(self, 10, 100, 6)
            sleep()
        end,
        --Flings every object into a different random direction
        [11] = function()
            flingAll(self, 10, math.random(8, 30))
            sleep()
        end,
        --Flings every object into a random direction
        [12] = function()
            fling(self, 10, math.random(8, 30))
            sleep()
        end,
        --Shoots bullets in every direction
        [13] = function()
            shootAround(self, 50, "gun")
            sleep()
        end,
        --Shoots rockets in every direction
        [14] = function()
            shootAround(self, 50, "rocket")
            sleep()
        end,
        --Shatter
        [15] = function()
            for x=1, 5 do
                MakeHole(selfPos, 4, 4, 4)
            end
            sleep()
        end,
    }
    
    --ROLL
    luckVal = math.random(0, #drops)

    --GET DROP
    drops[luckVal]()
end