#include "../../quickMath.lua"

--CONTAINS THE FUNCTIONS USED FOR SOME DROPS
function push(self, size, power)
    local bodies, minPos, maxPos = getObjects(self, size)

    for x=1, #bodies do
        local bodyPos = GetBodyTransform(bodies[x]).pos
        local pushPower = VecScale(VecNormalize(VecSub(selfPos, bodyPos)), -power)
        SetBodyVelocity(bodies[x], pushPower)
    end

    --FOR PLAYER
    local playerPos = GetPlayerTransform().pos
    if isInBounds(playerPos, minPos, maxPos) then
        local pushPower = VecScale(VecNormalize(VecSub(selfPos, playerPos)), -power)
        SetPlayerVelocity(pushPower)
    end
end
function napalm(self, rayDist, amount, explosionChance)
    local selfPos = GetBodyTransform(self).pos
    for x=1, amount do
        local newDir = VecNormalize(randVec(-1, 1, 4))

        QueryRejectBody(self)
        local hit, dist = QueryRaycast(selfPos, newDir, rayDist, 0, false)

        if hit then
            local firePos = VecAdd(VecScale(newDir, dist), selfPos)
            SpawnFire(firePos)
            if math.random(0, explosionChance) == 0 then Explosion(firePos, 0) end
        end
    end
end
function flingAll(self, size, power)
    local bodies, minPos, maxPos = getObjects(self, size)

    for x=1, #bodies do
        local bodyPos = GetBodyTransform(bodies[x]).pos
        local pushPower = VecScale(VecNormalize(randVec(-1, 1, 3)), -power)
        SetBodyVelocity(bodies[x], pushPower)
    end

    --FOR PLAYER
    local playerPos = GetPlayerTransform().pos
    if isInBounds(playerPos, minPos, maxPos) then
        local pushPower = VecScale(VecNormalize(randVec(-1, 1, 3)), -power)
        SetPlayerVelocity(pushPower)
    end
end
function fling(self, size, power)
    local bodies, minPos, maxPos = getObjects(self, size)
    local pushPower = VecScale(VecNormalize(randVec(-1, 1, 3)), -power)

    for x=1, #bodies do
        local selfPos = GetBodyTransform(self).pos
        SetBodyVelocity(bodies[x], pushPower)
    end

    --FOR PLAYER
    local playerPos = GetPlayerTransform().pos
    if isInBounds(playerPos, minPos, maxPos) then
        SetPlayerVelocity(pushPower)
    end
end
function shootAround(self, amount, bulletType)
    for x=1, amount do
        local selfPos = GetBodyTransform(self).pos
        local randDir = VecNormalize(randVec(-1, 1, 3))
        Shoot(selfPos, randDir, bulletType)
    end
end